#define AppName "7-ade"
#define AppVersion "1.0"
#define AppPublisher "Daniel Beardsmore"
#define AppURL "http://telcontar.net/Software/7-ade/"
#define AppExe AppName + ".exe"

[Setup]
AppId={{930BC7AE-2923-4828-A9C4-54941A9846C8}
AppName={#AppName}
AppVersion={#AppVersion}
AppVerName={#AppName} {#AppVersion}
AppPublisher={#AppPublisher}
AppPublisherURL={#AppURL}
AppSupportURL={#AppURL}
AppUpdatesURL={#AppURL}
DefaultDirName={pf}\Telcontar\{#AppName}
DefaultGroupName=7-ade
OutputBaseFilename={#AppName} setup
OutputDir=.
SetupIconFile=Installer.ico
Compression=lzma
SolidCompression=yes
UninstallDisplayIcon={app}\{#AppExe}
LicenseFile=Build\Licence.txt
ChangesAssociations=true

[Languages]
Name: "english"; MessagesFile: "compiler:Default.isl"

[Files]
Source: "Build\{#AppExe}"; DestDir: "{app}"; Flags: ignoreversion
Source: "Build\Icons\*"; DestDir: "{app}\Icons"; Flags: ignoreversion
Source: "Build\Licence.txt"; DestDir: "{app}"; Flags: ignoreversion
Source: "Build\Readme.pdf"; DestDir: "{app}"; Flags: ignoreversion
; NOTE: Don't use "Flags: ignoreversion" on any shared system files

[Icons]
Name: "{group}\{#AppName}"; Filename: "{app}\{#AppExe}"
Name: "{group}\{#AppName} readme"; Filename: "{app}\Readme.pdf"

[Registry]
#define RegCo "SOFTWARE\Telcontar"
#define RegApp RegCo + "\" + AppName

; Find 7-Zip
#define SevenPath ReadReg(HKLM, "SOFTWARE\7-Zip", "Path", ReadReg(HKLM64, "SOFTWARE\7-Zip", "Path", "ERROR"))

; Application
Root: HKLM; Subkey: "{#RegCo}"; Flags: uninsdeletekeyifempty
Root: HKLM; Subkey: "{#RegApp}"; Flags: uninsdeletekey
Root: HKLM; Subkey: "{#RegApp}\shell\open\command"; ValueType: string; ValueName: ""; ValueData: """{app}\{#AppExe}"""
Root: HKLM; Subkey: "SOFTWARE\RegisteredApplications"; ValueType: string; ValueName: "{#AppName}"; ValueData: "{#RegApp}\Capabilities"

Root: HKLM; Subkey: "{#RegApp}\Capabilities"; ValueType: string; ValueName: "ApplicationName"; ValueData: "7-ade"
Root: HKLM; Subkey: "{#RegApp}\Capabilities"; ValueType: string; ValueName: "ApplicationDescription"; ValueData: "Sensible Archive expander based for 7-Zip"
Root: HKLM; Subkey: "{#RegApp}"; ValueType: string; ValueName: "InstallPath"; ValueData: "{app}"

; File types
#define FileTypeExtension
#define FileTypeIcon
#define FileTypeDescription

#sub RegisterType
   Root: HKCR; Subkey: "{#AppName}.{#FileTypeExtension}"; ValueType: string; ValueName: ""; ValueData: "{#FileTypeDescription}"
   Root: HKCR; Subkey: "{#AppName}.{#FileTypeExtension}\DefaultIcon"; ValueType: string; ValueName: ""; ValueData: "{app}\Icons\{#FileTypeIcon}.ico"
   Root: HKCR; Subkey: "{#AppName}.{#FileTypeExtension}\shell\open"; ValueType: string; ValueName: ""; ValueData: "Expand"
   Root: HKCR; Subkey: "{#AppName}.{#FileTypeExtension}\shell\open\command"; ValueType: string; ValueName: ""; ValueData: """{app}\{#AppExe}"" ""%1"""
   #if SevenPath != "ERROR"
      Root: HKCR; Subkey: "{#AppName}.{#FileTypeExtension}\shell\view"; ValueType: string; ValueName: ""; ValueData: "View in 7-Zip"
      Root: HKCR; Subkey: "{#AppName}.{#FileTypeExtension}\shell\view\command"; ValueType: string; ValueName: ""; ValueData: """{#SevenPath}\7zFM.exe"" ""%1"""
   #endif
   Root: HKLM; Subkey: "{#RegApp}\Capabilities\FileAssociations"; ValueType: string; ValueName: ".{#FileTypeExtension}"; ValueData: "{#AppName}.{#FileTypeExtension}"
#endsub

#define CallRegisterType(str ext, str icon, str dest) \
   FileTypeExtension = ext, \
   FileTypeIcon = icon, \
   FileTypeDescription = dest, \
   RegisterType

#expr CallRegisterType("7Z", "7Z", "7-Zip archive")
#expr CallRegisterType("BZ2", "BZ2", "bzip2 archive")
#expr CallRegisterType("BZIP2", "BZIP2", "bzip2 archive")
#expr CallRegisterType("GZ", "GZ", "gzip archive")
#expr CallRegisterType("GZIP", "GZ", "gzip archive")
#expr CallRegisterType("RAR", "RAR", "RAR archive")
#expr CallRegisterType("RPM", "RPM", "Red Hat package")
#expr CallRegisterType("TAR", "other", "Tape archive")
#expr CallRegisterType("TBZ", "other", "Tarball")
#expr CallRegisterType("TBZ2", "other", "Tarball")
#expr CallRegisterType("TGZ", "TGZ", "Tarball")
#expr CallRegisterType("TXZ", "other", "Tarball")
#expr CallRegisterType("XZ", "other", "XZ archive")
#expr CallRegisterType("ZIP", "ZIP", "Zip file")

[Run]
Filename: "{app}\Readme.pdf"; Description: "View the readme"; Flags: postinstall shellexec skipifsilent unchecked